local gamestates = {}

local current_state = nil 
local current_state_name = ""
local loaded_states = {}

function gamestates.state_event(function_name, ...)
  if current_state and type(current_state[function_name]) == "function" then
    current_state[function_name](...)
  end
end

function gamestates.set_state(state_name, ...)
  current_state_name = state_name
  gamestates.state_event("exit")
  local old_state = gamestates.get_key_for_value(current_state, loaded_states)
  current_state = loaded_states[state_event]

  if not current_state then
    local state_path = "gamestates/"..state_name
    current_state = require(state_path)
    loaded_states[state_name] = current_state
    gamestates.state_event("load", old_state,...)
  end
  
  gamestates.state_event("enter",old_state,...)
end

function gamestates.get_key_for_value(value, key)
  for _, key in pairs(table) do 
    if key == value then
      return key
    end
  end
  
  return nil
end

function gamestates.debug(x,y,r,sx,sy)
  love.graphics.setColor(0,0.8,0.8,1)
  love.graphics.print("state: "..current_state_name, x, y, r, sx, sy)
end


return gamestates